//****************************************************************************
//
//	  MrTip 2012 www.banerled.pl
//    CPU STM32F103VET6
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    AUTHOR SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//    PROGRAM ZAWARTY W TYM PLIKU PRZEZNACZONY JEST WYLACZNIE
//    DO CELOW SZKOLENIOWYCH. AUTOR NIE PONOSI ODPOWIEDZIALNOSCI
//    ZA ZADNE EWENTUALNE, BEZPOSREDNIE I POSREDNIE SZKODY
//    WYNIKLE Z JEGO WYKORZYSTANIA.
//******************************************************************************


#include "tft_pcf8833_lib.h"
#include "stm32f10x_gpio.h"
#include "fonts/Fonts16x16.c"
#include "iType.h"
#include <ctype.h>

unsigned char Screen [132][132];	//kolor RRRGGGBB

const unsigned char cpolskie[32] = {'ą','ć','ę','ł','ń','ó','ś','ź','ż','Ą','Ć','Ę','Ł','Ń','Ó','Ś','Ź','Ż',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '};
const U16 LcdX = 131;
const U16 LcdY = 131;
const U16 LcdMax  = LcdX * LcdY; //10240

extern uint8_t			   Jasnosc;    //0-15

//-----------------------------------------------------------------------------------------------------------------------
void TFTN_AnimateToBox(uint8_t col)
{
	unsigned int i,x,y;                                 

	for (i=1;i<66;i+=2)
	{
		TFTN_SendCmd(CASET); // Set column address range
		TFTN_SendData(66-i);
		TFTN_SendData(66+i);	

		TFTN_SendCmd(PASET);// Set row address range
		TFTN_SendData(66-i);
		TFTN_SendData(66+i);
  
	// Write memory
		TFTN_SendCmd(RAMWR);
		for (x=0;x<(i*i*4);x++) TFTN_SendData(col);
		TFTN_SendCmd(NOP);
		
	}                  
};
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_AnimateToScreen(void)
{
	unsigned int i,x,y;                                 
	for (i=0;i<132;i+=2)
	{
		TFTN_SendCmd(CASET); // Set column address range
		TFTN_SendData(0);
		TFTN_SendData(i);	

		TFTN_SendCmd(PASET);// Set row address range
		TFTN_SendData(0);
		TFTN_SendData(i);
  
	// Write memory
		TFTN_SendCmd(RAMWR);
		for (y=0;y<i+1;y++) for (x=0;x<i+1;x++) TFTN_SendData(Screen[y][131-x]);
		TFTN_SendCmd(NOP);
	}
};
//-----------------------------------------------------------------------------------------------------------------------
void Inputs2TFTN(void)
{
	unsigned int x,y;                                 

	TFTN_SendCmd(CASET); // Set column address range
	TFTN_SendData(101);
	TFTN_SendData(131);	

	TFTN_SendCmd(PASET);// Set row address range
	TFTN_SendData(0);
	TFTN_SendData(131);
  
	// Write memory
	TFTN_SendCmd(RAMWR);
	for (x=0;x<132;x++) for (y=0;y<31;y++) TFTN_SendData(Screen[x][30-y]);
    TFTN_SendCmd(NOP);
	
}
//-----------------------------------------------------------------------------------------------------------------------
void Outputs2TFTN(void)
{
	unsigned int x,y;                                 


	TFTN_SendCmd(CASET); // Set column address range
	TFTN_SendData(  0);
	TFTN_SendData( 30);	

	TFTN_SendCmd(PASET);// Set row address range
	TFTN_SendData(0);
	TFTN_SendData(131);
  
	// Write memory
	TFTN_SendCmd(RAMWR);
	for (x=0;x<132;x++) for (y=0;y<31;y++) TFTN_SendData(Screen[x][131-y]);
    TFTN_SendCmd(NOP);
	
}
//-----------------------------------------------------------------------------------------------------------------------
void Clock2TFTN(void)
{
	unsigned int x,y;                                 

	TFTN_SendCmd(CASET); // Set column address range
	TFTN_SendData(30);
	TFTN_SendData(101);	

	TFTN_SendCmd(PASET);// Set row address range
	TFTN_SendData(0);
	TFTN_SendData(131);
  
	// Write memory
	TFTN_SendCmd(RAMWR);
	for (x=0;x<132;x++) for (y=30;y<102;y++) TFTN_SendData(Screen[x][131-y]);
    TFTN_SendCmd(NOP);
	
}
//-----------------------------------------------------------------------------------------------------------------------
void Screen2TFTN(void)
{
	unsigned int x,y;                                 

	TFTN_SendCmd(CASET); // Set column address range
	TFTN_SendData(0);
	TFTN_SendData(131);	

	TFTN_SendCmd(PASET);// Set row address range
	TFTN_SendData(0);
	TFTN_SendData(131);
  
#ifdef EPSON
// Write memory
	TFTN_SendCmd(RAMWR);
	for (y=0;y<132;y++) for (x=0;x<132;x++) TFTN_SendData(Screen[y][131-x]);
    TFTN_SendCmd(NOP);
#endif

#ifdef PHILLIPS
// Write memory
	TFTN_SendCmd(RAMWR);
	for (y=0;y<132;y++) for (x=0;x<132;x++) TFTN_SendData(Screen[y][131-x]);
    TFTN_SendCmd(NOP);
#endif	
	
}
//-----------------------------------------------------------------------------------------------------------------------
void FillScreen(char Color)
{
	unsigned int x,y;
	for (y=0;y<132;y++) for (x=0;x<132;x++) Screen[x][y]=Color;

}
//-----------------------------------------------------------------------------------------------------------------------
void FillRectScreen(int xs, int ys, int xe, int ye,char Color)
{
	int x,y;
	for (y=0;y<(ye-ys);y++) for (x=0;x<(xe-xs);x++) TFTN_PutPixel(x+xs,y+ys,Color);

}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_HwConfig(void)
{ //Hardware configuration (GPIO) for Nokia 6610 TFT (Philips PCF8833)
  //NOTE: since TFT needs 9-bit word transmision, SPI controller in STM32 CANNOT be used
	GPIO_InitTypeDef  GPIO_InitStructure; 

  //GPIO config                
	GPIO_InitStructure.GPIO_Pin =TFTN_CLK | TFTN_MISO | TFTN_MOSI;    //SPI: SCK, MISO and MOSI lines
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(TFTN_GPIO, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = TFTN_SS;                            //SPI: SS line
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(TFTN_GPIO, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = TFTN_RES;                           //RES
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(TFTN_GPIO, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin =TFTL_LIGHT;    //Light
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(TFTL_GPIO, &GPIO_InitStructure);
	GPIO_SetBits(TFTL_GPIO, TFTL_LIGHT);							//Light on 
} 
//-----------------------------------------------------------------------------------------------------------------------
void LCDLightOff(void)
{
	LCDLight(0);
	GPIO_ResetBits(TFTL_GPIO, TFTL_LIGHT);							//Light off
}
//-----------------------------------------------------------------------------------------------------------------------
void LCDLightOn(void)
{
	GPIO_SetBits(TFTL_GPIO, TFTL_LIGHT);							//Light off
	LCDLight(15);
}
//-----------------------------------------------------------------------------------------------------------------------
#ifdef EPSON
void TFTN_Init_Epson(void){
	int j;

    TFTN_SendCmd(DISCTL);  		// display control(EPSON)
    TFTN_SendData(12);   		// 12 = 1100 - CL dividing ratio [don't divide] switching period 8H (default)
	TFTN_SendData(32);			// 130 line display
	TFTN_SendData(15);			// no inversely highlighted lines

	
    TFTN_SendCmd(COMSCN);  		// common scanning direction(EPSON)
    TFTN_SendData(0x01);
    
    TFTN_SendCmd(OSCON);  		// internal oscillator ON(EPSON)
	
    TFTN_SendCmd(SLPOUT);  		// sleep out(EPSON)

	TFTN_SendCmd(VOLCTR);  		// electronic volume, this is the contrast/brightness(EPSON)
	TFTN_SendData(0x0);   		// KONTRAST ***************************
	TFTN_SendData(0x3);   		// ZAWSZE 3 internal resistor ratio - coarse adjustment

//	TFTN_SendCmd(VOLCTR);  		// electronic volume, this is kinda contrast/brightness
//	TFTN_SendData(5);//ff);     //  this might be different for individual LCDs
//	TFTN_SendData(0x01);//01);  //


    TFTN_SendCmd(PWRCTR); 		// power ctrl(EPSON)
    TFTN_SendData(0x0F);    	//everything on, no external reference resistors
	for (j=0;j<100000;j++) __nop;

	TFTN_SendCmd(DISINV);  		// invert display mode(EPSON)

	TFTN_SendCmd(TMPGRD);  		// Average temperature
    TFTN_SendData(0x00);		// -0.05

    TFTN_SendCmd(DATCTL);  		// data control(EPSON)
    TFTN_SendData(0x00);		// direction,rotation,Inverse 3 bity
	TFTN_SendData(0x00);   		// normal RGB arrangement
	TFTN_SendData(0x01);		// 1= 8 gray scale/ 2= 16 gray

	TFTN_SendCmd(RGBSET8);   // setup color lookup table
    // color table
    //RED
    TFTN_SendData(0);
    TFTN_SendData(2);
    TFTN_SendData(4);
    TFTN_SendData(6);
    TFTN_SendData(8);
    TFTN_SendData(10);
    TFTN_SendData(12);
    TFTN_SendData(15);
    // GREEN
    TFTN_SendData(0);
    TFTN_SendData(2);
    TFTN_SendData(4);
    TFTN_SendData(6);
    TFTN_SendData(8);
    TFTN_SendData(10);
    TFTN_SendData(12);
    TFTN_SendData(15);
    //BLUE
    TFTN_SendData(0);
    TFTN_SendData(4);
    TFTN_SendData(9);
    TFTN_SendData(15);

    TFTN_SendCmd(NOP);  	// nop(EPSON)

	for(j=0; j<300000; j++) __nop;
	
    TFTN_SendCmd(DISON);   	// display on(EPSON)
}
#endif
//-----------------------------------------------------------------------------------------------------------------------
#ifdef	PHILLIPS

void TFTN_Init_Philips(void){
	int j,i;

//	TFTN_SendCmd(SOFT_RESET);  	// Software Reset
	TFTN_SendCmd(SLEEPOUT); 	// Sleep Out
	TFTN_SendCmd(BSTRON);  	// Booster ON
	for(i = 0; i < 200000ul; i++) __nop;

	TFTN_SendCmd(SETCON);         
	TFTN_SendData(60);            //-64~63, this value must be set individually for your display

	TFTN_SendCmd(EC);				//Internal/external oscillator register bits
	TFTN_SendData(0);

	TFTN_SendCmd(COLMOD);
	TFTN_SendData(2);

	TFTN_SendCmd(SETMUL);			//multiplication factor - x2,x3,x4,x5 - 0,1,2,3
	TFTN_SendData(2);

	TFTN_SendCmd(TCDF);				//TEMPERATURE FRAME FREQUENCY PROGRAMMING
	TFTN_SendData(0x38);	
	TFTN_SendData(0x35);
	TFTN_SendData(0x30);
	TFTN_SendData(0x25);
	
	TFTN_SendCmd(DF8COLOR);
	TFTN_SendData(0x38);
	
	TFTN_SendCmd(SETBS);
	TFTN_SendData(0x7);            //0-F
	
	TFTN_SendCmd(RGBSET);         
	TFTN_SendData(0x00);
	TFTN_SendData(0x02);
	TFTN_SendData(0x03);
	TFTN_SendData(0x04);
	TFTN_SendData(0x05);
	TFTN_SendData(0x06);
	TFTN_SendData(0x08);
	TFTN_SendData(0x0F);

	TFTN_SendData(0x00);
	TFTN_SendData(0x02);
	TFTN_SendData(0x03);
	TFTN_SendData(0x04);
	TFTN_SendData(0x05);
	TFTN_SendData(0x06);
	TFTN_SendData(0x08);
	TFTN_SendData(0x0F);

	TFTN_SendData(0x00);
	TFTN_SendData(0x03);
	TFTN_SendData(0x06);
	TFTN_SendData(0x0F);

	TFTN_SendCmd(INVON);		// invert display mode(PHILLIPS)

	TFTN_SendCmd(MADCTL);
	TFTN_SendData((0x01 << MX) | (0x01 << RGB));

	TFTN_SendCmd(NOP);   // Display ON
	
	TFTN_SendCmd(DISPON);   // Display ON
}
#endif
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_Init (void)
{
	volatile unsigned long int i;

	GPIO_SetBits(TFTN_GPIO, TFTN_SS | TFTN_CLK |TFTN_MOSI);		
	GPIO_ResetBits(TFTN_GPIO, TFTN_RES);	//RES=0
	for (i=0;i<100000ul;i++) __nop;
	GPIO_SetBits(TFTN_GPIO, TFTN_RES);		//RES=1
	for (i=0;i<100000ul;i++) __nop;

//	_TFTN_Init();

//	return;

#ifdef EPSON
	TFTN_Init_Epson();
#endif
#ifdef	PHILLIPS
	TFTN_Init_Philips();
#endif
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_SendCmd(unsigned char cCmd){
  //Send command word to display
	TFTN_GPIO->BRR=TFTN_SS | TFTN_CLK | TFTN_MOSI;	//GPIO_ResetBits(TFTN_GPIO, TFTN_SS | TFTN_CLK | TFTN_MOSI);		 //SCE=0 (ENABLE) 
	TFTN_GPIO->BSRR=TFTN_CLK; 						//GPIO_SetBits(TFTN_GPIO, TFTN_CLK);		 

	if ((cCmd&0x80))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x40))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x20))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x10))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x08))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x04))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x02))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cCmd&0x01))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	
//	TFTN_Transmit(cCmd);
	TFTN_GPIO->BSRR=TFTN_SS;							//GPIO_SetBits(TFTN_GPIO, TFTN_SS);		 
	
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_SendData(unsigned char cData){
  //Send data word to display
	TFTN_GPIO->BRR=TFTN_SS | TFTN_CLK;				//GPIO_ResetBits(TFTN_GPIO, TFTN_SS | TFTN_CLK);		 //SCE=0 (ENABLE)
	TFTN_GPIO->BSRR=TFTN_MOSI;						//GPIO_SetBits(TFTN_GPIO, TFTN_MOSI);		 
	TFTN_GPIO->BSRR=TFTN_CLK; 						//GPIO_SetBits(TFTN_GPIO, TFTN_CLK);		 

	if ((cData&0x80))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x40))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x20))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x10))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x08))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x04))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x02))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	if ((cData&0x01))	TFTN_GPIO->BSRR=TFTN_MOSI; else	TFTN_GPIO->BRR=TFTN_MOSI; TFTN_GPIO->BRR=TFTN_CLK; TFTN_GPIO->BSRR=TFTN_CLK;
	
	TFTN_GPIO->BSRR=TFTN_SS;						//GPIO_SetBits(TFTN_GPIO, TFTN_SS);		 
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_Clear(unsigned int color)
{  //Clear display
		TFTN_FillRect(0, 0, 131, 131, color);
}
//-----------------------------------------------------------------------------------------------------------------------
unsigned char Polskie (unsigned char c)
{
	U8 i,r;
	r=c;
	if (c>128) r=' ';
	for (i=0;i<18;i++) if (cpolskie[i]==c) r=i;
	return r;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------
U16 len_text16x16(char* textptr)
{
   U16 ln,i;
   
   ln=0;
   for(i=0; textptr[i] != '\0'; i++) ln +=WidthFont16x16[Polskie(textptr[i])];					// jesli poza x=0
   return ln;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------
// Purpose:       Write text on a graphic LCD
// Inputs:        (x,y) - The upper left coordinate of the first letter
//                textptr - A pointer to an array of text to display
//                size - The size of the text: 1 = 5x7, 2 = 10x14, ...
//				  RGB Color B RGB Background
//				  opt 
//					0 - nothing
//					1 - no background
//					2 - no color
//					3 - inverse all
//					4 - inverse color
//					5 - inverse background
//					6 - outline in background
//------------------------------------------------------------------------------------------------------------------------------------------------------
void TFTN_text16x16s(int x, int y, char* textptr, char color, char background, unsigned char opt)
{
	int len;
	len=len_text16x16(textptr); len=x-(len>>1); 
	TFTN_text16x16(len, y, textptr, color, background, opt);
};
//------------------------------------------------------------------------------------------------------------------------------------------------------
void TFTN_text16x16(int x, int y, char* textptr, char color, char background, unsigned char opt)
{
   U8 bt,i,k,l;
   unsigned char col;
   U16 xr,yr;
   U32 f,e;
   int Lcd_X,xb,yb;
//   U8 w;
   Lcd_X=LcdX;
   if (opt==6)
   {
		xb=x;yb=y;
	                for(i=0; textptr[i] != '\0'; i++) { bt=Polskie(textptr[i]); if (bt<127) { if (x>-16) { if (x<Lcd_X) { for(k=0; k<16; ++k) { f=Font16x16[bt][k];f=f<<16; for(l=0;l<WidthFont16x16[bt]; l++){ e=(1 << (31-l));e=f & e;xr=x+l; yr=y+k;if(e!=0) TFTN_PutPixel(xr, yr-1, background);}}}}}x=x+WidthFont16x16[bt];}
		x=xb; y=yb; for(i=0; textptr[i] != '\0'; i++) { bt=Polskie(textptr[i]); if (bt<127) { if (x>-16) { if (x<Lcd_X) { for(k=0; k<16; ++k) { f=Font16x16[bt][k];f=f<<16; for(l=0;l<WidthFont16x16[bt]; l++){ e=(1 << (31-l));e=f & e;xr=x+l; yr=y+k;if(e!=0) TFTN_PutPixel(xr, yr+1, background);}}}}}x=x+WidthFont16x16[bt];}
		x=xb; y=yb; for(i=0; textptr[i] != '\0'; i++) { bt=Polskie(textptr[i]); if (bt<127) { if (x>-16) { if (x<Lcd_X) { for(k=0; k<16; ++k) { f=Font16x16[bt][k];f=f<<16; for(l=0;l<WidthFont16x16[bt]; l++){ e=(1 << (31-l));e=f & e;xr=x+l; yr=y+k;if(e!=0) TFTN_PutPixel(xr-1, yr, background);}}}}}x=x+WidthFont16x16[bt];}
		x=xb; y=yb; for(i=0; textptr[i] != '\0'; i++) { bt=Polskie(textptr[i]); if (bt<127) { if (x>-16) { if (x<Lcd_X) { for(k=0; k<16; ++k) { f=Font16x16[bt][k];f=f<<16; for(l=0;l<WidthFont16x16[bt]; l++){ e=(1 << (31-l));e=f & e;xr=x+l; yr=y+k;if(e!=0) TFTN_PutPixel(xr+1, yr, background);}}}}}x=x+WidthFont16x16[bt];}
		x=xb; y=yb; for(i=0; textptr[i] != '\0'; i++) { bt=Polskie(textptr[i]); if (bt<127) { if (x>-16) { if (x<Lcd_X) { for(k=0; k<16; ++k) { f=Font16x16[bt][k];f=f<<16; for(l=0;l<WidthFont16x16[bt]; l++){ e=(1 << (31-l));e=f & e;xr=x+l; yr=y+k;if(e!=0) TFTN_PutPixel(xr, yr, color);}}}}}x=x+WidthFont16x16[bt];}
   }
   else
   {
		for(i=0; textptr[i] != '\0'; i++) 					// Loop through the passed string
		{
			bt=Polskie(textptr[i]);     
			if (bt<127)
			{ 
				if (x>-16) 										// jesli poza LedX
				{
				if (x<Lcd_X)
			  	  {  
				  for(k=0; k<16; ++k)          				// Loop through the vertical pixels
					{
					f=Font16x16[bt][k];
					f=f<<16;									//od bitu 31		
					for(l=0;l<WidthFont16x16[bt]; l++)							
						{   
						e=(1 << (31-l));
						e=f & e;
						xr=x+l; yr=y+k;
				
						if (opt==0)
						  {
							if(e!=0) TFTN_PutPixel(xr, yr, color); 			// Draws the pixel
							if(e==0) TFTN_PutPixel(xr, yr, background); 		// Draws the pixel
						  }
						if (opt==1)
						  {
							if(e!=0) TFTN_PutPixel(xr, yr, color); 			// Draws the pixel
						  }  	
						if (opt==2)
						  {
							if(e==0) TFTN_PutPixel(xr, yr, background); 		// Draws the pixel
						  }	
						if (opt==3)
						  {  
							if(e!=0) { col=Screen[xr][yr]; col=col^color; TFTN_PutPixel(xr, yr, col); }			// Draws the pixel
							if(e==0) { col=Screen[xr][yr]; col=col^background; TFTN_PutPixel(xr, yr, col); }			// Draws the pixel
						  }
						if (opt==4)
						  { 
							if(e!=0) { col=Screen[xr][yr]; col=col^color; TFTN_PutPixel(xr, yr, col); }			// Draws the pixel
						  }
						if (opt==5)
						  {
							if(e==0) { col=Screen[xr][yr]; col=col^background; TFTN_PutPixel(xr, yr, col); }			// Draws the pixel
						  }
						}	
					}
				  }  
				}
			}	
	        x=x+WidthFont16x16[bt];
		}
	}		
 }
//------------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------
void TFTN_Rectangle(int x0, int y0, int x1, int y1, unsigned int color){
	TFTN_Line(x0,y0,x1,y0,color);
	TFTN_Line(x0,y1,x1,y1,color);
	TFTN_Line(x0,y0,x0,y1,color);
	TFTN_Line(x1,y0,x1,y1,color);
}
//------------------------------------------------------------------------------------------------------------------------------------------------------
void TFTN_FillRect(int x0, int y0, int x1, int y1, unsigned int color){
  //Draw rectangle between x0,y0 and x1,y1
	unsigned int i;
	int swapBuf; 
	unsigned int x,y;

	if (x0>x1) 
	{
		swapBuf=x1;
		x1=x0;
		x0=swapBuf;
	}

	if (y0>y1) 
	{
		swapBuf=y1;
		y1=y0;
		y0=swapBuf;
	}
	for (y=y0;y<y1;y++) for (x=x0;x<x1;x++) Screen[x][y]=color;
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_PutPixel(int x, int y, unsigned int color) {
  //Set a color of a pixel in x, y position
	if (x>-1) if (y>-1) if (x<132) if (y<132) Screen[x][y]=color;	//check oversize
}
//-----------------------------------------------------------------------------------------------------------------------                                                                                                                         
void TFTN_Line(int x0, int y0, int x1, int y1, unsigned int color){
  //Draw line from x0, y0 to x1, y1
  //algorithm taken from http://www.sparkfun.com/tutorial/Nokia%206100%20LCD%20Display%20Driver.pdf
  //and                  http://www.cs.unc.edu/~mcmillan/comp136/Lecture6/Lines.html
  int dy = y1 - y0;
  int dx = x1 - x0;
  int stepx, stepy;
  int fraction;

  if (dy < 0) { dy = -dy; stepy = -1; } else { stepy = 1; }
  if (dx < 0) { dx = -dx; stepx = -1; } else { stepx = 1; }
  dy <<= 1; // dy is now 2*dy
  dx <<= 1; // dx is now 2*dx
  TFTN_PutPixel(x0, y0, color);
  if (dx > dy) {
    fraction = dy - (dx >> 1); // same as 2*dy - dx
    while (x0 != x1) {
      if (fraction >= 0) {
        y0 += stepy;
        fraction -= dx; // same as fraction -= 2*dx
      }
      x0 += stepx;
      fraction += dy; // same as fraction -= 2*dy
      TFTN_PutPixel(x0, y0, color);
    }
  } else {
    fraction = dx - (dy >> 1);
    while (y0 != y1) {
      if (fraction >= 0) {
        x0 += stepx;
        fraction -= dy;
      }
      y0 += stepy;
      fraction += dx;
      TFTN_PutPixel(x0, y0, color);
    }
  }
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_Circle(int x0, int y0, int radius, unsigned int color) {
  //Draw circle with a center in x0,y0 and a given radius
  //algorithm taken from http://www.sparkfun.com/tutorial/Nokia%206100%20LCD%20Display%20Driver.pdf

  int f = 1 - radius;
  int ddF_x = 0;
  int ddF_y = -2 * radius;
  int x = 0;
  int y = radius;

  TFTN_PutPixel(x0, y0 + radius, color);     //s1
  TFTN_PutPixel(x0, y0 - radius, color);     //s2
  TFTN_PutPixel(x0 + radius, y0, color);     //s3
  TFTN_PutPixel(x0 - radius, y0, color);     //s4
  while (x < y) {
    if (f >= 0) {
      y--;
      ddF_y += 2;
      f += ddF_y;
    }
    x++;
    ddF_x += 2;
    f += ddF_x + 1;
    TFTN_PutPixel(x0 + x, y0 + y, color);     //1
    TFTN_PutPixel(x0 - x, y0 + y, color);     //2
    TFTN_PutPixel(x0 + x, y0 - y, color);     //3
    TFTN_PutPixel(x0 - x, y0 - y, color);     //4
    TFTN_PutPixel(x0 + y, y0 + x, color);     //5
    TFTN_PutPixel(x0 - y, y0 + x, color);     //6
    TFTN_PutPixel(x0 + y, y0 - x, color);     //7
    TFTN_PutPixel(x0 - y, y0 - x, color);     //8
  }
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_FillCircle(int x0, int y0, int radius, unsigned int color) {
  //Draw circle filled with color with a center in x0,y0 and a given radius

	int f = 1 - radius;
	int ddF_x = 0;
	int ddF_y = -2 * radius;
	int x = 0;
	int y = radius;

	TFTN_FillRect(x0, y0 + radius, x0, y0 - radius, color); //s1-2  , draw rectangle instead of vertical line - faster
	TFTN_PutPixel(x0 + radius, y0, color);                  //s3
	TFTN_PutPixel(x0 - radius, y0, color);                  //s4
	while (x < y) 
		{
			if (f >= 0) 
				{
					y--;
					ddF_y += 2;
					f += ddF_y;
				}
			x++;
			ddF_x += 2;
			f += ddF_x + 1;

			TFTN_FillRect(x0 + x, y0 + y, x0 + x, y0 - y, color);  //1-3
			TFTN_FillRect(x0 - x, y0 + y, x0 - x, y0 - y, color);  //2-4
			TFTN_FillRect(x0 + y, y0 + x, x0 + y, y0 - x, color);  //5-7
			TFTN_FillRect(x0 - y, y0 + x, x0 - y, y0 - x, color);  //6-8
		}
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_WriteBMP(const unsigned int *buffer, int xPos, int yPos, int xSize, int ySize){
	//Draw bitmap
	unsigned int x,y,i;
    i=0;
	for (y=yPos;y<(yPos+ySize);y++)
	for (x=xPos;x<(xPos+xSize);x++)
	TFTN_PutPixel(x,y,buffer[i]);	//check oversize
}
//-----------------------------------------------------------------------------------------------------------------------
// X - start draw
// Y - end draw
// opt - options
//		0 - normal copy
//		1 - inverse
//		2 - repeat X
//		3 - repeat Y
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_Bitmap(int px, int py, int opt, int optd, const unsigned char * bmp)
{
	int xs,xq;
	int ys,yq;
	int x,y,i;
	unsigned char color;
	
	xs=bmp[0];
	ys=bmp[1];

	if (opt==0)	//normal copy
		{
			i=2;
			for (y=py;y<(py+ys);y++) for (x=px;x<(px+xs);x++) TFTN_PutPixel(x,y,bmp[i++]);
		}
	if (opt==1)	//normal copy
		{
			i=2;
			for (y=py;y<(py+ys);y++) for (x=px;x<(px+xs);x++) 
			{
				color=bmp[i++]^Screen[x][y]; //XOR
				TFTN_PutPixel(x,y,color);
			};
		}

	if (opt==2)	//repeat X
		{
			for (xq=0;xq<((optd*xs)+xs);xq+=xs)
				{
					i=2;
					for (y=py;y<(py+ys);y++) for (x=px;x<(px+xs);x++) TFTN_PutPixel(x+xq,y,bmp[i++]);
				};
		};
	
}
//-----------------------------------------------------------------------------------------------------------------------
//   opt - oprion 
//	0 - normal draw
//	1 - color optd outline draw -
void TFTN_Button(int x, int y, int opt, int optd, unsigned char *text) //font 16x16
{
	int xs,xq;
	int ys,yq;

	xs=len_text16x16(text)+13;
	ys=23;

	if (opt==0)
	{
		TFTN_FillRect(x,y,x+xs,y+ys,R5|G5|B3);
	
		TFTN_Line(x    ,y    ,x+xs ,y   , R3|G3|B1); //black
		TFTN_Line(x+xs ,y    ,x+xs ,y+ys, R3|G3|B1); //black
		TFTN_Line(x    ,y+ys ,x+xs ,y+ys, R3|G3|B1); //black
		TFTN_Line(x    ,y    ,x    ,y+ys, R3|G3|B1); //black

		x++; y++;
		xs-=2; ys-=2;
		TFTN_Line(x    ,y    ,x+xs ,y   , 0); //black
		TFTN_Line(x+xs ,y    ,x+xs ,y+ys, 0); //black
		TFTN_Line(x    ,y+ys ,x+xs ,y+ys, 0); //black
		TFTN_Line(x    ,y    ,x    ,y+ys, 0); //black
	
		x++; y++;
		xs-=2; ys-=2;
		TFTN_Line(x    ,y    ,x+xs ,y   , R7|G7|B3);
		TFTN_Line(x    ,y    ,x    ,y+ys, R7|G7|B3);
		TFTN_Line(x+xs ,y    ,x+xs ,y+ys, R1|G1|B1);
		TFTN_Line(x    ,y+ys ,x+xs ,y+ys, R1|G1|B1);

		x++; y++;
		xs-=2; ys-=2;
		TFTN_Line(x    ,y    ,x+xs ,y   , R6|G6|B3);
		TFTN_Line(x    ,y    ,x    ,y+ys, R6|G6|B3);

		x+=3; 
		TFTN_text16x16(x, y, text, 0, R5|G5|B3, 0); //no background draw
	}
	if (opt==1)
	{
		TFTN_Line(x    ,y    ,x+xs ,y   , optd); //black
		TFTN_Line(x+xs ,y    ,x+xs ,y+ys, optd); //black
		TFTN_Line(x    ,y+ys ,x+xs ,y+ys, optd); //black
		TFTN_Line(x    ,y    ,x    ,y+ys, optd); //black

		x++; y++;
		xs-=2; ys-=2;
//		TFTN_Line(x    ,y    ,x+xs ,y   , optd); //black
//		TFTN_Line(x+xs ,y    ,x+xs ,y+ys, optd); //black
//		TFTN_Line(x    ,y+ys ,x+xs ,y+ys, optd); //black
//		TFTN_Line(x    ,y    ,x    ,y+ys, optd); //black

		x++; y++;
		x++; y++;
		x+=3; 
		TFTN_text16x16(x, y, text, optd, BLACK, 6); //no background draw
		
	}
}
//-----------------------------------------------------------------------------------------------------------------------
void MakeHomeScreen(void)
{
	uint8_t x,y;
	uint16_t i,k;
	for (y=0;y<30;y++)		for (x=0;x<132;x++) Screen[x][y]=B1;
	for (y=30;y<102;y++)	for (x=0;x<132;x++) Screen[x][y]=B2;
	
	for (y=102;y<132;y++)	for (x=0;x<132;x++) Screen[x][y]=B1;

	for (x=0;x<132;x++) {Screen[x][26]=B1;};
	for (x=0;x<132;x++) {Screen[x][27]=B2;};
	for (x=0;x<132;x++) {Screen[x][28]=B3;};
	for (x=0;x<132;x++) {Screen[x][29]=B2;};

	for (x=0;x<132;x++) {Screen[x][102]=B2;};
	for (x=0;x<132;x++) {Screen[x][103]=B3;};
	for (x=0;x<132;x++) {Screen[x][104]=B2;};
	for (x=0;x<132;x++) {Screen[x][105]=B1;};

	for (x=0;x<9;x++) {    TFTN_Circle(10+(x*14),8,1,BLACK);};
	for (x=0;x<9;x++) {    TFTN_Circle(10+(x*14),8,2,BLACK);};
	for (x=0;x<9;x++) {    TFTN_Circle(10+(x*14),8,3,BLACK);};
	for (x=0;x<9;x++) {    TFTN_Circle(10+(x*14),8,4,BLACK);};
	for (x=0;x<9;x++) {    TFTN_Circle(10+(x*14),8,6,BLACK);};
	for (x=0;x<9;x++) {    TFTN_Circle(10+(x*14),8,5,B3);};
	for (x=0;x<7;x++) {    TFTN_Circle(14+(x*17),123,1,BLACK);};
	for (x=0;x<7;x++) {    TFTN_Circle(14+(x*17),123,2,BLACK);};
	for (x=0;x<7;x++) {    TFTN_Circle(14+(x*17),123,3,BLACK);};
	for (x=0;x<7;x++) {    TFTN_Circle(14+(x*17),123,4,BLACK);};
	for (x=0;x<7;x++) {    TFTN_Circle(14+(x*17),123,6,BLACK);};
	for (x=0;x<7;x++) {    TFTN_Circle(14+(x*17),123,5,B3);};

		
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_RamkaUp (void)
{
	TFTN_Line(  1,105,131,105,B1);
	TFTN_Line(  1,105,  1,130,B1);
	TFTN_Line(  1,130,131,130,B1);
	TFTN_Line(130,105,130,130,B1);

	TFTN_Line(  2,  1,129, 1,R5|G5);
	TFTN_Line(  1,  2,  1,25,R5|G5);
	TFTN_Line(  2, 26,129,26,R5|G5);
	TFTN_Line(130,  2,130,25,R5|G5);
}
//-----------------------------------------------------------------------------------------------------------------------
void TFTN_RamkaDown (void)
{
	TFTN_Line(  1,  1,131, 1,B1);
	TFTN_Line(  1,  1,  1,26,B1);
	TFTN_Line(  1, 26,131,26,B1);
	TFTN_Line(130,  1,130,26,B1);

	TFTN_Line(  2,105,129,105,R5|G5);
	TFTN_Line(  1,106,  1,129,R5|G5);
	TFTN_Line(  2,130,129,130,R5|G5);
	TFTN_Line(130,106,130,129,R5|G5);
};
//-----------------------------------------------------------------------------------------------------------------------
void BlurVertical(int xs, int ys, int xe, int ye)
{
	int x,y;
	uint8_t cola, colb;
	int	ra,ga,ba,rb,gb,bb;
	
	for (x=0;x<(xe-xs);x++)
		for (y=0;y<(ye-ys);y++)
		{
			cola=Screen[xs+x][ys+y];
			colb=Screen[xs+x][ys+y+1];
			if (cola!=colb)
				{
					ra=cola>>5;			ga=(cola>>2)&7;			ba=cola&3;
					rb=colb>>5;			gb=(colb>>2)&7;			bb=colb&3;
					ra=ra>>1; rb=rb>>1; ra=ra+rb+1;
					ga=ga>>1; gb=gb>>1; ga=ga+gb+1;
					ba=ba>>1; bb=bb>>1; ba=ba+bb+1;
					cola=ra<<5|ga<<2|ba;
					Screen[xs+x][ys+y]=cola;
				};
		};
};
//-----------------------------------------------------------------------------------------------------------------------
void BlurHorizontal(int xs, int ys, int xe, int ye)
{
	int x,y;
	uint8_t cola, colb;
	int	ra,ga,ba,rb,gb,bb;
	
	for (x=0;x<(xe-xs);x++)
		for (y=0;y<(ye-ys);y++)
		{
			cola=Screen[xs+x][ys+y];
			colb=Screen[xs+x+1][ys+y];
			if (cola!=colb)
				{
					ra=cola>>5;			ga=(cola>>2)&7;			ba=cola&3;
					rb=colb>>5;			gb=(colb>>2)&7;			bb=colb&3;
					ra=ra>>1; rb=rb>>1; ra=ra+rb+1;
					ga=ga>>1; gb=gb>>1; ga=ga+gb+1;
					ba=ba>>1; bb=bb>>1; ba=ba+bb+1;
					cola=ra<<5|ga<<2|ba;
					Screen[xs+x][ys+y]=cola;
				};
		};
};
//-----------------------------------------------------------------------------------------------------------------------
void Blur(int xs, int ys, int xe, int ye)
{
	BlurHorizontal(xs,ys,xe,ye);
	BlurVertical(xs,ys,xe,ye);
}
//-----------------------------------------------------------------------------------------------------------------------
